unofficial mirror of bug-guix@gnu.org 
 help / color / mirror / code / Atom feed
* bug#23475: no code for module (guix ui)
@ 2016-05-07  2:59 Leo Famulari
  2016-05-08 16:10 ` Ludovic Courtès
  0 siblings, 1 reply; 7+ messages in thread
From: Leo Famulari @ 2016-05-07  2:59 UTC (permalink / raw)
  To: 23475

From commit bdb2d56ee (gnu: mutt: Update to 1.6.1.), I applied a patch
from guix-devel [0], tried to build a package, and got a backtrace as
shown below.

I had rebuilt from the git tree recently, but I'm not sure exactly when.

It goes away after I rebuild.

---
$ ./pre-inst-env guix build hello
Backtrace:                               
In ice-9/boot-9.scm:
 157: 12 [catch #t #<catch-closure 19e4ba0> ...]
In unknown file:
   ?: 11 [apply-smob/1 #<catch-closure 19e4ba0>]
In ice-9/boot-9.scm:
  63: 10 [call-with-prompt prompt0 ...]
In ice-9/eval.scm:
 432: 9 [eval # #]
In ice-9/boot-9.scm:
2401: 8 [save-module-excursion #<procedure 1a01940 at ice-9/boot-9.scm:4045:3 ()>]
4050: 7 [#<procedure 1a01940 at ice-9/boot-9.scm:4045:3 ()>]
1724: 6 [%start-stack load-stack ...]
1729: 5 [#<procedure 1a18ea0 ()>]
In unknown file:
   ?: 4 [primitive-load "/gnu/store/9p7mf2a21c6a5k06jgbb9yg9abx7ilh9-guix-0.10.0-0.8062/bin/.guix-real"]
In ice-9/eval.scm:
 411: 3 [eval # #]
 387: 2 [eval # #]
In ice-9/boot-9.scm:
2867: 1 [resolve-interface (guix ui) #:select ...]
In unknown file:
   ?: 0 [scm-error misc-error #f "~A ~S" ("no code for module" (guix ui)) #f]

ERROR: In procedure scm-error:
ERROR: no code for module (guix ui)
---

[0] I've had this issue several times recently, without this patch.

It was this patch:
http://lists.gnu.org/archive/html/guix-devel/2016-05/msg00204.html

It commits as 13416a10afdbad6546ef7943d93aba795ee5703b

^ permalink raw reply	[flat|nested] 7+ messages in thread

* bug#23475: no code for module (guix ui)
  2016-05-07  2:59 bug#23475: no code for module (guix ui) Leo Famulari
@ 2016-05-08 16:10 ` Ludovic Courtès
  2016-05-22 21:36   ` Ludovic Courtès
  0 siblings, 1 reply; 7+ messages in thread
From: Ludovic Courtès @ 2016-05-08 16:10 UTC (permalink / raw)
  To: Leo Famulari; +Cc: 23475

[-- Attachment #1: Type: text/plain, Size: 1132 bytes --]

Leo Famulari <leo@famulari.name> skribis:

> I had rebuilt from the git tree recently, but I'm not sure exactly when.
>
> It goes away after I rebuild.
>
> ---
> $ ./pre-inst-env guix build hello
> Backtrace:                               
> In ice-9/boot-9.scm:
>  157: 12 [catch #t #<catch-closure 19e4ba0> ...]
> In unknown file:
>    ?: 11 [apply-smob/1 #<catch-closure 19e4ba0>]
> In ice-9/boot-9.scm:
>   63: 10 [call-with-prompt prompt0 ...]
> In ice-9/eval.scm:
>  432: 9 [eval # #]
> In ice-9/boot-9.scm:
> 2401: 8 [save-module-excursion #<procedure 1a01940 at ice-9/boot-9.scm:4045:3 ()>]
> 4050: 7 [#<procedure 1a01940 at ice-9/boot-9.scm:4045:3 ()>]
> 1724: 6 [%start-stack load-stack ...]
> 1729: 5 [#<procedure 1a18ea0 ()>]
> In unknown file:
>    ?: 4 [primitive-load "/gnu/store/9p7mf2a21c6a5k06jgbb9yg9abx7ilh9-guix-0.10.0-0.8062/bin/.guix-real"]

Why is this file being loaded, instead of scripts/guix?  Could it be
that scripts/guix was missing at that time?

Maybe it would be wise to apply a patch as attached to prevent such
situations from arising.  WDYT?

Thanks,
Ludo’.


[-- Attachment #2: Type: text/x-patch, Size: 590 bytes --]

--- a/build-aux/pre-inst-env.in
+++ b/build-aux/pre-inst-env.in
@@ -1,7 +1,7 @@
 #!/bin/sh
 
 # GNU Guix --- Functional package management for GNU
-# Copyright © 2012, 2013, 2014, 2015 Ludovic Courtès <ludo@gnu.org>
+# Copyright © 2012, 2013, 2014, 2015, 2016 Ludovic Courtès <ludo@gnu.org>
 #
 # This file is part of GNU Guix.
 #
@@ -68,4 +68,11 @@ export NIX_HASH
 GUIX_UNINSTALLED=1
 export GUIX_UNINSTALLED
 
+guix="$abs_top_builddir/scripts/guix"
+if [ ! -x "$guix" ]
+then
+    echo "'$guix' is missing, please run 'make'." >&2
+    exit 1
+fi
+
 exec "$@"

^ permalink raw reply	[flat|nested] 7+ messages in thread

* bug#23475: no code for module (guix ui)
  2016-05-08 16:10 ` Ludovic Courtès
@ 2016-05-22 21:36   ` Ludovic Courtès
  2016-05-23  3:22     ` Leo Famulari
  0 siblings, 1 reply; 7+ messages in thread
From: Ludovic Courtès @ 2016-05-22 21:36 UTC (permalink / raw)
  To: Leo Famulari; +Cc: 23475

Ping!  :-)

Ludo’.

ludo@gnu.org (Ludovic Courtès) skribis:

> Leo Famulari <leo@famulari.name> skribis:
>
>> I had rebuilt from the git tree recently, but I'm not sure exactly when.
>>
>> It goes away after I rebuild.
>>
>> ---
>> $ ./pre-inst-env guix build hello
>> Backtrace:                               
>> In ice-9/boot-9.scm:
>>  157: 12 [catch #t #<catch-closure 19e4ba0> ...]
>> In unknown file:
>>    ?: 11 [apply-smob/1 #<catch-closure 19e4ba0>]
>> In ice-9/boot-9.scm:
>>   63: 10 [call-with-prompt prompt0 ...]
>> In ice-9/eval.scm:
>>  432: 9 [eval # #]
>> In ice-9/boot-9.scm:
>> 2401: 8 [save-module-excursion #<procedure 1a01940 at ice-9/boot-9.scm:4045:3 ()>]
>> 4050: 7 [#<procedure 1a01940 at ice-9/boot-9.scm:4045:3 ()>]
>> 1724: 6 [%start-stack load-stack ...]
>> 1729: 5 [#<procedure 1a18ea0 ()>]
>> In unknown file:
>>    ?: 4 [primitive-load "/gnu/store/9p7mf2a21c6a5k06jgbb9yg9abx7ilh9-guix-0.10.0-0.8062/bin/.guix-real"]
>
> Why is this file being loaded, instead of scripts/guix?  Could it be
> that scripts/guix was missing at that time?
>
> Maybe it would be wise to apply a patch as attached to prevent such
> situations from arising.  WDYT?
>
> Thanks,
> Ludo’.
>
> --- a/build-aux/pre-inst-env.in
> +++ b/build-aux/pre-inst-env.in
> @@ -1,7 +1,7 @@
>  #!/bin/sh
>  
>  # GNU Guix --- Functional package management for GNU
> -# Copyright © 2012, 2013, 2014, 2015 Ludovic Courtès <ludo@gnu.org>
> +# Copyright © 2012, 2013, 2014, 2015, 2016 Ludovic Courtès <ludo@gnu.org>
>  #
>  # This file is part of GNU Guix.
>  #
> @@ -68,4 +68,11 @@ export NIX_HASH
>  GUIX_UNINSTALLED=1
>  export GUIX_UNINSTALLED
>  
> +guix="$abs_top_builddir/scripts/guix"
> +if [ ! -x "$guix" ]
> +then
> +    echo "'$guix' is missing, please run 'make'." >&2
> +    exit 1
> +fi
> +
>  exec "$@"

^ permalink raw reply	[flat|nested] 7+ messages in thread

* bug#23475: no code for module (guix ui)
  2016-05-22 21:36   ` Ludovic Courtès
@ 2016-05-23  3:22     ` Leo Famulari
  2016-07-31 16:40       ` Ludovic Courtès
  0 siblings, 1 reply; 7+ messages in thread
From: Leo Famulari @ 2016-05-23  3:22 UTC (permalink / raw)
  To: Ludovic Courtès; +Cc: 23475

On Sun, May 22, 2016 at 11:36:38PM +0200, Ludovic Courtès wrote:
> >>    ?: 4 [primitive-load "/gnu/store/9p7mf2a21c6a5k06jgbb9yg9abx7ilh9-guix-0.10.0-0.8062/bin/.guix-real"]
> >
> > Why is this file being loaded, instead of scripts/guix?  Could it be
> > that scripts/guix was missing at that time?

It happened again, and scripts/guix was present. Next time I will take a
snapshot of the broken state.

^ permalink raw reply	[flat|nested] 7+ messages in thread

* bug#23475: no code for module (guix ui)
  2016-05-23  3:22     ` Leo Famulari
@ 2016-07-31 16:40       ` Ludovic Courtès
  2016-08-02  1:30         ` Leo Famulari
  0 siblings, 1 reply; 7+ messages in thread
From: Ludovic Courtès @ 2016-07-31 16:40 UTC (permalink / raw)
  To: Leo Famulari; +Cc: 23475

Leo Famulari <leo@famulari.name> skribis:

> On Sun, May 22, 2016 at 11:36:38PM +0200, Ludovic Courtès wrote:
>> >>    ?: 4 [primitive-load "/gnu/store/9p7mf2a21c6a5k06jgbb9yg9abx7ilh9-guix-0.10.0-0.8062/bin/.guix-real"]
>> >
>> > Why is this file being loaded, instead of scripts/guix?  Could it be
>> > that scripts/guix was missing at that time?
>
> It happened again, and scripts/guix was present. Next time I will take a
> snapshot of the broken state.

Any updates?  :-)

Ludo’.

^ permalink raw reply	[flat|nested] 7+ messages in thread

* bug#23475: no code for module (guix ui)
  2016-07-31 16:40       ` Ludovic Courtès
@ 2016-08-02  1:30         ` Leo Famulari
  2016-08-02  9:17           ` Ludovic Courtès
  0 siblings, 1 reply; 7+ messages in thread
From: Leo Famulari @ 2016-08-02  1:30 UTC (permalink / raw)
  To: Ludovic Courtès; +Cc: 23475

On Sun, Jul 31, 2016 at 06:40:00PM +0200, Ludovic Courtès wrote:
> Any updates?  :-)

I've noticed that it happens if I do this:

$ guix gc && ./pre-inst-env guix build foo

If I then do the following, it works again:

$ guix environment guix
$ exit
$ ./pre-inst-env guix build foo 

I don't have all of the Guix dependencies in my profile or my Debian
environment (I see this on my Debian machine), so I guess that something
important is garbage collected, but I haven't figured out what yet.

So, I think it's not much of a bug, since I am deliberately invoking the
garbage collector. WDYT?

^ permalink raw reply	[flat|nested] 7+ messages in thread

* bug#23475: no code for module (guix ui)
  2016-08-02  1:30         ` Leo Famulari
@ 2016-08-02  9:17           ` Ludovic Courtès
  0 siblings, 0 replies; 7+ messages in thread
From: Ludovic Courtès @ 2016-08-02  9:17 UTC (permalink / raw)
  To: Leo Famulari; +Cc: 23475

Leo Famulari <leo@famulari.name> skribis:

> On Sun, Jul 31, 2016 at 06:40:00PM +0200, Ludovic Courtès wrote:
>> Any updates?  :-)
>
> I've noticed that it happens if I do this:
>
> $ guix gc && ./pre-inst-env guix build foo
>
> If I then do the following, it works again:
>
> $ guix environment guix
> $ exit
> $ ./pre-inst-env guix build foo 
>
> I don't have all of the Guix dependencies in my profile or my Debian
> environment (I see this on my Debian machine), so I guess that something
> important is garbage collected, but I haven't figured out what yet.
>
> So, I think it's not much of a bug, since I am deliberately invoking the
> garbage collector. WDYT?

Possibly.  If you use ./configure -C, the ‘config.cache’ file also gets
stale after GC.  But even if you don’t, (guix config) might be referring
to things that have been collected, so you have to:

  rm -f config.cache && ./configure

I’m closing this bug, but do reopen it if you think something’s really
broken.  :-)

Thanks!

Ludo’.

^ permalink raw reply	[flat|nested] 7+ messages in thread

end of thread, other threads:[~2016-08-02  9:18 UTC | newest]

Thread overview: 7+ messages (download: mbox.gz / follow: Atom feed)
-- links below jump to the message on this page --
2016-05-07  2:59 bug#23475: no code for module (guix ui) Leo Famulari
2016-05-08 16:10 ` Ludovic Courtès
2016-05-22 21:36   ` Ludovic Courtès
2016-05-23  3:22     ` Leo Famulari
2016-07-31 16:40       ` Ludovic Courtès
2016-08-02  1:30         ` Leo Famulari
2016-08-02  9:17           ` Ludovic Courtès

Code repositories for project(s) associated with this public inbox

	https://git.savannah.gnu.org/cgit/guix.git

This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for read-only IMAP folder(s) and NNTP newsgroup(s).